#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "fila.h"

//cdigo associado  posio no vetor
typedef struct {
  char nome[20];
  char autor[20];
  int usuario;//-1 se estiver disponvel na biblioteca
} Livro;

//cdigo associado  posio no vetor
typedef struct{
  char nome[20];
  char tipo[20];
} Usuario;

//Imprime opes menu
void imprime_menu(){
     printf("Menu : \n"); 
     printf("IU\t insere usuario:\t\t IU <nome> <tipo> (sem espacos)\n");     
     printf("IL\t insere livro:\t\t\t IL <nome> <autor> (sem espacos) \n");
     printf("EL\t empresa livro:\t\t\t DL <cod livro> <cod usuario>\n");
     printf("DL\t devolve livro:\t\t\t DL <cod livro>\n");
     printf("RL\t reserva livro:\t\t\t RL <cod livro> <cod usuario>\n");
     printf("PR\t proximo na reserva:\t\t PR <cod livro>\n");
     printf("CU\t consulta usuarios:\t\t CU \n");
     printf("CL\t consulta livros:\t\t CL\n");
     printf("FE\t finaliza execucao:\t\t FE\n");
}
     
int main(void) {
    int erro, nlivros=0, nusuarios=0, codlivro, codusuario, i,auxuser=0;
    Livro livros[30];
    Usuario usuarios[50];
    Fila reservas[30];
    char opcao[3];

    for (i=0;i<30;i++) Create(&reservas[i]);
    
    do{
      imprime_menu();
      printf("\n");
      scanf("%s",opcao);
      if(!strcmp(opcao,"IU")){//insere usurio: IU <nome> <tipo> (sem espacos)
        scanf("%s %s",usuarios[nusuarios].nome,usuarios[nusuarios].tipo);
        nusuarios++;
      }
      else if(!strcmp(opcao,"IL")){//insere livro: IL <nome> <autor> (sem espacos)
        scanf("%s %s",livros[nlivros].nome,livros[nlivros].autor); 
        livros[nlivros].usuario=-1;                                   
        nlivros++;
      }
      else if(!strcmp(opcao,"EL")){//empresta livro: EL <cod livro> <cod usuario>
        scanf("%d %d",&codlivro,&codusuario);
        livros[codlivro].usuario=codusuario;
      }
      else if(!strcmp(opcao,"DL")){//devolve livro: DL <cod livro>
        scanf("%d",&codlivro);
        livros[codlivro].usuario=-1;
      }
      else if(!strcmp(opcao,"RL")){//reserva livro: RL <cod livro> <cod usuario>
        scanf("%d %d",&codlivro,&codusuario);
        Entra(&reservas[codlivro],&codusuario,&erro);
      }
      else if(!strcmp(opcao,"PR")){//prximo na reserva: PR <cod livro>
        scanf("%d",&codlivro);
        Sai(&reservas[codlivro],&codusuario,&erro);
        printf("Proximo na fila: %d\n",codusuario);
      }
      else if(!strcmp(opcao,"CU")){//consulta usuario: CU
        for (auxuser=0;auxuser<nusuarios;auxuser++){
          printf("Codigo: %d\nNome: %s\nTipo: %s\n",auxuser,usuarios[auxuser].nome,usuarios[auxuser].tipo);
          printf("\n\n");
        }
      }
      else if(!strcmp(opcao,"CL")){//consulta livros: CL
        for (codlivro=0;codlivro<nlivros;codlivro++){
          printf("Codigo: %d\nNome: %s\nAutor: %s\nEmprestado: %d\nReservas: ",codlivro,livros[codlivro].nome,livros[codlivro].autor,livros[codlivro].usuario);
          Imprime(&reservas[codlivro]);
          printf("\n\n");
        }
      }
       printf("\n");
    }while(strcmp(opcao,"FE"));//finaliza execuo: FE

    system("pause");
    return 0;
}
